并查集解题报告

题目一:

HDOJ 1213

网址:http://acm.hdu.edu.cn/showproblem.php?pid=1213

问题描述

Today is Ignatius' birthday. He invites a lot of friends. Now it'sdinner time. Ignatius wants to know how many tables he needs at least. You haveto notice that not all the friends know each other, and all the friends do notwant to stay with strangers.

One important rule for this problem is that if I tell you A knows B, and Bknows C, that means A, B, C know each other, so they can stay in one table.

For example: If I tell you A knows B, B knows C, and D knows E, so A, B, C canstay in one table, and D, E have to stay in the other one. So Ignatius needs 2tables at least.

 

输入

The input starts with an integer T(1<=T<=25) which indicatethe number of test cases. Then T test cases follow. Each test case starts withtwo integers N and M(1<=N,M<=1000). N indicates the number of friends,the friends are marked from 1 to N. Then M lines follow. Each line consists oftwo integers A and B(A!=B), that means friend A and friend B know each other.There will be a blank line between two cases.

 

输出

For each test case, just output how many tables Ignatius needs atleast. Do NOT print any blanks.

 

示例输入

2

5 3

1 2

2 3

4 5

 

5 1

2 5

 

示例输出

2

4

解题思路:

解这道题可以用两个数组,第一个int数组用来存放标记为当前数组下标的朋友与哪个朋友认识,当两个标记不同的朋友认识的最后一个朋友相同时说明这两个朋友也互相认识。第二个vector数组用来存放认识的最后一个朋友,那么需要桌子的数量就等于vector数组的长度。

程序:

#include<iostream>

#include<vector>

usingnamespace std;

 

int* p;

 

int Find(intx)

{

    if(x == p[x])

       returnx;

    else

       return Find(p[x]);

}

 

void Merge(intp1, intp2)

{

    p1 = Find(p1), p2 = Find(p2);

    if(p1 != p2)

       p[p1] = p2;

}

 

int main()

{

    int T;

    cin >> T;

    for(int i = 0; i < T; i++)

    {

       int N, M,s;

       vector<int> k;

       cin >> N >> M;

       p = newint[N+1];

       for(int j = 1; j <= N; j++)

           p[j] = j;

       for(int j = 0; j < M; j++)

       {

           int p1, p2;

           cin >> p1 >> p2;

           Merge(p1, p2);

       }

       s = Find(p[1]);

       k.push_back(s);

       for(int j = 2; j <= N; j++)

       {

           int m =Find(p[j]);

           if(m != s)

           {

              int t = 0;

              for(int l = 0; l < k.size(); l++)

              {

                  if(m == k[l])

                  {

                     t = 1;

                     break;

                  }

              }

              if(t == 0)

                  k.push_back(m);

           }

           s = m;

       }

       cout <<k.size() << endl;

       delete[] p;

    }

    return 0;

}

题目二:

HDOJ 1232

网址:http://acm.hdu.edu.cn/showproblem.php?pid=1232

问题描述

某省调查城镇交通状况,得到现有城镇道路统计表,表中列出了每条道路直接连通的城镇。省政府畅通工程的目标是使全省任何两个城镇间都可以实现交通(但不一定有直接的道路相连,只要互相间接通过道路可达即可)。问最少还需要建设多少条道路?

 

输入

测试输入包含若干测试用例。每个测试用例的第1行给出两个正整数,分别是城镇数目N ( < 1000 )和道路数目M;随后的M行对应M条道路,每行给出一对正整数,分别是该条道路直接连通的两个城镇的编号。为简单起见,城镇从1N编号。 
注意:两个城市之间可以有多条道路相通,也就是说
3 3
1 2
1 2
2 1

这种输入也是合法的
N0时,输入结束,该用例不被处理。 

 

输出

对每个测试用例,在1行里输出最少还需要建设的道路数目。 

 

示例输入

4 2

1 3

4 3

3 3

1 2

1 3

2 3

5 2

1 2

3 5

999 0

0

 

示例输出

1

0

2

998

 

 

 

解题思路:

这道题可以用一个int数组和一个vector数组来解,int数组用来存放编号为当前数组下标的城镇与哪个城镇相通,通过并查集的方法可以查找到编号为当前数组下标的城镇最终通向的城镇的编号,如果两个编号不同的城镇最终通向的城镇相同,说明这两个城镇之间是连通的。vector数组存放最终通向的城镇的编号,因此vector数组的长度减一就是最少还需要建设的道路数目。

 

 

 

程序:

#include<iostream>

#include<vector>

usingnamespace std;

 

int* p;

 

int Find(intx)

{

    if (x == p[x])

       returnx;

    else

       return Find(p[x]);

}

 

void Merge(intp1, intp2)

{

    p1 = Find(p1), p2 = Find(p2);

    if (p1 != p2)

       p[p1] = p2;

}

 

int main()

{

    int N, n,s;

    while (cin >> N)

    {

       if (N ==0)

           break;

       cin >> n;

       p = newint[N + 1];

       vector<int> k;

       for (int i = 1; i <= N; i++)

           p[i] = i;

       for (int i = 0; i < n; i++)

       {

           int p1, p2;

           cin >> p1 >> p2;

           Merge(p1, p2);

       }

       s = Find(p[1]);

       k.push_back(s);

       for (int i = 2; i <= N; i++)

       {

           int m =Find(p[i]);

           if (m !=s)

           {

              int t = 0;

              for (int j = 0; j < k.size(); j++)

              {

                  if (k[j] == m)

                  {

                     t = 1;

                     break;

                  }

              }

              if (t ==0)

                  k.push_back(m);

           }

           s = m;

       }

       cout <<k.size() - 1 << endl;

       delete[] p;

    }

    return 0;

}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值